PROGRAM Analyser (INPUT, OUTPUT);
{
   Daniel U. Thibault  78 840 046
   25..26 Octobre 1988

   Modifi 15 Dcembre 1988
   Recompil 26 Janvier 1989 (nouveau codage)

   Programme permettant de charger un dictionnaire prpar
par le programme Dictionnaire (version 21+).

   Effectue diverses mesures diagnostiques.
}
CONST
   Max         = 524287; { 512k - 1 }

TYPE
   TTableau    = ARRAY [1..20] OF INTEGER;

   TChaine     = VARYING [32] OF CHAR;
   TNomFichier = VARYING [80] OF CHAR;

%INCLUDE 'DICO.TYP'

VAR
   Nom  : TNomFichier;
   Dico : TDico;

%INCLUDE 'DICO.PAS'

PROCEDURE Trier (VAR Tableau : TTableau;
		 VAR Element : INTEGER);
{
   Incrmente le bon lment du tableau (classement par puissances de deux)
}
BEGIN { Trier }
   IF Element < 2
   THEN
      Tableau [1] := Tableau [1] + 1
   ELSE IF Element <       4 THEN
      Tableau [2] := Tableau [2] + 1
   ELSE IF Element <       8 THEN
      Tableau [3] := Tableau [3] + 1
   ELSE IF Element <      16 THEN
      Tableau [4] := Tableau [4] + 1
   ELSE IF Element <      32 THEN
      Tableau [5] := Tableau [5] + 1
   ELSE IF Element <      64 THEN
      Tableau [6] := Tableau [6] + 1
   ELSE IF Element <     128 THEN
      Tableau [7] := Tableau [7] + 1
   ELSE IF Element <     512 THEN
      Tableau [8] := Tableau [8] + 1
   ELSE IF Element <    1024 THEN
      Tableau [9] := Tableau [9] + 1
   ELSE IF Element <    2048 THEN
      Tableau [10] := Tableau [10] + 1
   ELSE IF Element <    4096 THEN
      Tableau [11] := Tableau [11] + 1
   ELSE IF Element <    8192 THEN
      Tableau [12] := Tableau [12] + 1
   ELSE IF Element <   16384 THEN
      Tableau [13] := Tableau [13] + 1
   ELSE IF Element <   32768 THEN
      Tableau [14] := Tableau [14] + 1
   ELSE IF Element <   65536 THEN
      Tableau [15] := Tableau [15] + 1
   ELSE IF Element <  131072 THEN
      Tableau [16] := Tableau [16] + 1
   ELSE IF Element <  262144 THEN
      Tableau [17] := Tableau [17] + 1
   ELSE IF Element <  524288 THEN
      Tableau [18] := Tableau [18] + 1
   ELSE IF Element < 1048576 THEN
      Tableau [19] := Tableau [19] + 1
   ELSE
      Tableau [20] := Tableau [20] + 1;
{  END IF }
END; { Trier }

PROCEDURE Examiner_Dico (VAR Dico : TDico);
{
   Examine le Dico.
}
VAR
   NDCurs,					{ Histogramme des tailles des
						  nuds-pointeurs }
   NDec,					{ Histogramme des valeurs des
						  nuds-pointeurs }
   NDecal     : TTableau;			{ Histogramme des valeurs des
						  pointeurs }
   NNFils1,					{ Histogramme des tailles des
						  familles de fils
						  (incluant queue et fils-suit) }
   NNFils2,					{ Histogramme des tailles des
						  familles de fils
						  (incluant fils-suit mais
						   excluant queue) }
   NNFils3    : ARRAY [0..63] OF INTEGER;	{ Histogramme des tailles des
						  familles de fils
						  (excluant queue et fils-suit) }
   NNoeuds,					{ Nombre de nuds }
   NFeuilles,					{ Nombre de feuilles }
   NFilsSuit,					{ Nombre de cas "fils suit" }
   NSansFils,					{ Nombre de cas "sans fils" }
   NPntrs,					{ Nombre de pointeurs }

   NFils,
   I,
   Dec,
   Decalage,
   Curs,
   Curseur   : INTEGER;
   Suivant,
   Feuille,
   Sans_Fils,
   Dernier   : BOOLEAN;

BEGIN { Examiner_Dico }
{
   Initialisations
}
   NNoeuds   := 0;
   NFeuilles := 0;
   NFilsSuit := 0;
   NSansFils := 0;
   NPntrs    := 0;
   FOR I := 1 TO 20 DO BEGIN
      NDCurs [I] := 0;
      NDec [I] := 0;
      NDecal [I] := 0;
   END; { FOR }
   FOR I := 0 TO 63 DO BEGIN
      NNFils1 [I] := 0;
      NNFils2 [I] := 0;
      NNFils3 [I] := 0;
   END; { FOR }

   Curseur  := 0;
   WHILE Curseur < Dico.Longueur DO BEGIN
{
   Q : Dico [Curseur] est un nud Lettre.
}
      NNoeuds := NNoeuds + 1;
      Sans_Fils := Pas_de_Fils (Dico, Curseur);
      IF Sans_Fils THEN NSansFils := NSansFils + 1;
      Suivant   := Fils_Suit (Dico, Curseur);
      IF Suivant   THEN NFilsSuit := NFilsSuit + 1;
      Feuille   := Est_une_Feuille (Dico, Curseur);
      IF Feuille   THEN NFeuilles := NFeuilles + 1;
      NFils := 0;
      IF NOT Sans_Fils
      THEN BEGIN
{
   Le nud a des fils loigns
}
         Decalage := 0;
         REPEAT
            Curs := Curseur;
            Dec := Lire_Decalage (Dico, Curseur, Dernier);
            Decalage := Decalage + Dec;
            NDCurs [Curseur - Curs] := NDCurs [Curseur - Curs] + 1;
            NPntrs := NPntrs + 1;
            NFils := NFils + 1;
            Trier (NDec,   Dec);
            Trier (NDecal, Decalage);
         UNTIL Dernier;
      END; { IF }
      NNFils3 [NFils] := NNFils3 [NFils] + 1;
      IF Suivant THEN NFils := NFils + 1;
      NNFils2 [NFils] := NNFils2 [NFils] + 1;
      IF Feuille THEN NFils := NFils + 1;
      NNFils1 [NFils] := NNFils1 [NFils] + 1;
   END; { WHILE }

   WRITELN ('Nombre de nuds:            ', NNoeuds);
   WRITELN ('   Nombre de feuilles:      ', NFeuilles);
   WRITELN ('   Nombre de fils suivants: ', NFilsSuit);
   WRITELN ('   Nombre de sans fils:     ', NSansFils);
   WRITELN;
   WRITELN ('Nombre de pointeurs:        ', NPntrs);
   WRITELN;

   WRITELN ('Histogramme des tailles des nuds-pointeurs:');
   FOR I := 1 TO 20 DO BEGIN
      IF NDCurs [I] > 0 THEN BEGIN
         WRITELN ('delta-curseur < 2^', I:2, ': ', NDCurs [I]);
      END; { IF }
   END; { FOR }
   WRITELN;

   WRITELN ('Histogramme des valeurs des nuds-pointeurs:');
   FOR I := 1 TO 20 DO BEGIN
      IF NDec [I] > 0 THEN BEGIN
         WRITELN ('Nombre de pointeurs < 2^', I:2, ': ', NDec [I]);
      END; { IF }
   END; { FOR }
   WRITELN;

   WRITELN ('Histogramme des valeurs des dcalages:');
   FOR I := 1 TO 20 DO BEGIN
      IF NDecal [I] > 0 THEN BEGIN
         WRITELN ('Nombre de dcalages < 2^', I:2, ': ', NDecal [I]);
      END; { IF }
   END; { FOR }
   WRITELN;

   WRITELN ('Histogramme des tailles des familles de fils');
   WRITELN ('(queue et fils suivant exclus):');
   FOR I := 0 TO 63 DO BEGIN
      IF NNFils3 [I] > 0 THEN BEGIN
         WRITELN ('Nombre de familles de ', I:2, ' pointeurs: ', NNFils3 [I]);
      END; { IF }
   END; { FOR }
   WRITELN;

   WRITELN ('Histogramme des tailles des familles de fils');
   WRITELN ('(queue exclue, fils suivant inclus):');
   FOR I := 0 TO 63 DO BEGIN
      IF NNFils2 [I] > 0 THEN BEGIN
         WRITELN ('Nombre de familles de ', I:2, ' pointeurs: ', NNFils2 [I]);
      END; { IF }
   END; { FOR }
   WRITELN;

   WRITELN ('Histogramme des tailles des familles de fils');
   WRITELN ('(queue et fils suivant inclus):');
   FOR I := 0 TO 63 DO BEGIN
      IF NNFils1 [I] > 0 THEN BEGIN
         WRITELN ('Nombre de familles de ', I:2, ' pointeurs: ', NNFils1 [I]);
      END; { IF }
   END; { FOR }
   WRITELN;
END; { Examiner_Dico }
{
 *************************************************************************
}
BEGIN { Analyser }
   WRITELN ('Programme d''analyse de fichiers .DIC');
   WRITELN ('Urhixidur, Janvier 1989');
   WRITELN;
   WRITE ('Fichier o se trouve le Dico? ');
   READLN (Nom);
   WRITELN; WRITELN;

   IF NOT Lire_Dico (Dico, Nom) THEN HALT;

   Examiner_Dico (Dico);

   Detruire_Dico (Dico);
END. { Analyser }
