PROGRAM Autotest (INPUT, OUTPUT);
{
   Daniel U. Thibault  78 840 046
   4 Novembre 1988
   11 Novembre 1988   Mesure du temps de consultation
   26 Janvier 1989    Intgration de l'objet Dico

   Vrifie l'orthographe de son propre vocabulaire source.
}
CONST
   Max             = 524287; { 512k - 1 }

TYPE
   TChaine         = VARYING [80] OF CHAR;
   TNomFichier     = TChaine;

%INCLUDE 'DICO.TYP'

VAR
   I,
   NMots,
   Horloge  : INTEGER;
   Mot, Nom : TChaine;
   Dico     : TDico;
   Source   : FILE OF BYTE;
   Sources,
   Vocab    : TEXT;

%INCLUDE 'DICO.PAS'

{
 *************************************************************************
}
BEGIN { Autotest }
   WRITELN ('Programme de vrification de fichiers .DIC');
   WRITELN ('Urhixidur, Janvier 1989');
   WRITELN;
   WRITE ('Fichier o se trouve le Dico? ');
   READLN (Nom);
   WRITELN; WRITELN;

   IF NOT Lire_Dico (Dico, Nom) THEN HALT;

   WRITE ('Fichier des morceaux du voca? ');
   READLN (Nom);
   OPEN (Sources, Nom, OLD);
   RESET (Sources);
   WHILE NOT EOF (Sources) DO BEGIN
      READLN (Sources, Nom);
      WRITELN ('Lecture du voca ', Nom);
      OPEN (Vocab, Nom, OLD);
      RESET (Vocab);
      WRITELN; WRITELN;
      NMots := 0;
      Horloge := 0;
      WHILE NOT EOF (Vocab) DO BEGIN
         READLN (Vocab, Mot);
         NMots := NMots + 1;
         Horloge := Horloge - CLOCK;
         CASE Consulter_Dico (Dico, Mot, I) OF
            Trouve      : Horloge := Horloge + CLOCK;
            Trop_Court  : BEGIN
                             Horloge := Horloge + CLOCK;
                             WRITELN (Mot, ' TROP COURT!  ',
                                      'Il manque un suffixe au Mot');
                          END;
            Trop_Long   : BEGIN
                             Horloge := Horloge + CLOCK;
                             WRITELN (Mot, ' TROP LONG!  ',
                                      'Le Mot a un suffixe de trop');
                          END;
            Indetermine : HALT
         END; { CASE }
      END; { WHILE }
      CLOSE (Vocab);
      WRITELN;
   END; { WHILE }
   CLOSE (Sources);

   WRITELN ('Vrification termine');
   WRITELN (NMots, ' mots en ', Horloge, ' ms');
   WRITELN;

   Detruire_Dico (Dico);
END. { Autotest }
