PROGRAM Compter (INPUT, OUTPUT);
{
   Daniel U. Thibault  78 840 046
   26 Janvier 1989

   Compte le nombre de chemins existant dans un Dico (vrification des
"Faux mots").
}
CONST
   Max         = 524287; { 512k - 1 }

TYPE
   TChaine     = VARYING [32] OF CHAR;
   TNomFichier = VARYING [80] OF CHAR;

%INCLUDE 'DICO.TYP'

VAR
   Nom   : TNomFichier;
   Dico  : TDico;
   NMots : INTEGER;

%INCLUDE 'DICO.PAS'

PROCEDURE Compter_Mots (VAR Dico  : TDico;
                        Curseur   : INTEGER;
                        VAR NMots : INTEGER);
{
   Compte le nombre de mots dans le sous-fuseau Dico [Curseur].
}
VAR
   Dec,
   Decalage  : INTEGER;
   Suivant,
   Feuille,
   Sans_Fils,
   Dernier   : BOOLEAN;

BEGIN { Compter_Mots }
   IF Curseur < Dico.Longueur
   THEN BEGIN
{
   Dico [Curseur] est un nud Lettre.
}
      Sans_Fils := Pas_de_Fils (Dico, Curseur);
      Suivant   := Fils_Suit (Dico, Curseur);
      Feuille   := Est_une_Feuille (Dico, Curseur);
      IF Feuille THEN NMots := NMots + 1;
      IF NOT Sans_Fils
      THEN BEGIN
{
   Le nud a des fils loigns
}
         Decalage := 0;
         REPEAT
            Dec := Lire_Decalage (Dico, Curseur, Dernier);
            Decalage := Decalage + Dec;
            Compter_Mots (Dico, Curseur+Decalage, NMots);
         UNTIL Dernier;
      END; { IF }
      IF Suivant
      THEN BEGIN
         Compter_Mots (Dico, Curseur, NMots);
      END; { IF }
   END; { IF }
END; { Compter_Mots }
{
 *************************************************************************
}
BEGIN { Compter }
   WRITELN ('Programme comptant le nombre d''pellations contenues ' +
            'dans un .DIC');
   WRITELN ('Urhixidur, Janvier 1989');
   WRITELN;
   WRITE ('Fichier o se trouve le Dico? ');
   READLN (Nom);
   WRITELN; WRITELN;

   IF NOT Lire_Dico (Dico, Nom) THEN HALT;

   NMots := 0;
   Compter_Mots (Dico, 0, NMots);
   WRITELN ('Le dico compte ', NMots, ' mots.');
   Detruire_Dico (Dico);
END. { Compter }
