PROGRAM Dictionnaire (INPUT, OUTPUT);
{
   Daniel U. Thibault  78 840 046
   6 Dcembre 1988
   20 Janvier 1989
   26 Janvier 1989   correction du codage ( et )

   Exprience portant sur la consolidation par tranches de vocabulaire.

    partir de fichiers texte contenant les pellations  stocker,
construit puis consolide le fuseau correspondant, et enfin le transcrit sous
une forme utilisable par la procdure de consultation (voir autre document).

   Intrant: le fichier des sources.  Ce fichier donne les sources  utiliser,
un fichier par ligne.  Chaque source est ajoute puis consolide.  Une fois
toutes les sources lues, on passe  la transcription.

    noter que les oprations de libration de la mmoire ont t
court-circuites, le systme se chargeant de cette besogne de faon bien plus
efficace que nous...d'autant plus que l'objet Mmoire ne relche pas au systme
la mmoire libre par l'usager!
}
CONST
   SNoeud   =  10; { Taille d'un nud d'un objet quelconque (MMOIRE) }
   CarTete  = 'a'; { Caractre de la Tte }
   CarQueue = 'z'; { Caractre de la Queue }

TYPE
   BYTE            = [UNSAFE] CHAR;
   TChaine         = VARYING [80] OF CHAR;
   Ternaire        = (Faux, Indetermine, Vrai);
   TPntrNoeud      = ^TNoeud;

%INCLUDE 'memoire.typ'

   TContListe      = TPntrNoeud;
%INCLUDE 'liste.typ'

%INCLUDE 'tamis.typ'

{ ******************** TYPES DE L'OBJET FUSEAU ******************** }

{  TPntrNoeud      = ^TNoeud; }

   TFuseau         = RECORD
                        NNoeuds,
                        NPntrs   : INTEGER;
                        Tete,
                        Queue    : TPntrNoeud
                     END;

   TNoeud          = RECORD
                        Lettre : CHAR;
                        Poids  : BYTE;
                        Peres  : TTamis;
                        CASE BOOLEAN OF
                           FALSE : (Fils : TListe);
                           TRUE  : (Coor : INTEGER)
                        END; { CASE }
{                    END RECORD }

{ +++++++++++++++++++ TYPES DE L'OBJET LINEAIRE +++++++++++++++++++ }

   TPntrNoeudLin   = ^TNoeudLin;
   TLineaire       = RECORD
                        Tete : TPntrNoeudLin;
                        CASE BOOLEAN OF
                           FALSE : (NOctets : INTEGER);
                           TRUE  : (Octets  : ARRAY [0..3] OF BYTE)
                        END; { CASE }
{                    END }
   TNoeudLin       = RECORD
                        Carac   : BYTE;
                        Noeud   : TPntrNoeud;
                        Suivant : TPntrNoeudLin
                     END;
   T64             = 1..64;
   TTab64          = ARRAY [T64] OF INTEGER;

VAR
   NOctets,
   Horloge  : INTEGER;
   Mot, Nom : TChaine;
   Mem      : TMemoire;
   Fuseau   : TFuseau;
   Sources,
   Source   : TEXT;
   Dest     : PACKED FILE OF BYTE;

%INCLUDE 'memoire.pas'
%INCLUDE 'liste.pas'
%INCLUDE 'tamis.pas'

{
 ******************** DBUT DE L'OBJET FUSEAU ********************
}
{
   Le Fuseau, une fois cr, consiste en nuds (contenu: une Lettre, un Poids,
un Tamis et une Liste), relis par des liens de parent.  Chaque nud a un
certain nombre de Fils et de Pres.  Les fils sont grs par Liste, les pres
par Tamis.  Le fuseau "vide" comprend en fait deux nuds privilgis, la Tte
et la Queue, utiliss pour encadrer tous les autres.

   Les pellations fournies par l'usager sont encadres des caractres CarTete
et CarQueue, afin de garantir une racine unique (la tte) et une feuille unique
(la Queue, voir le paragraphe suivant).

   Par construction (Ajouter_Fuseau), le fuseau est un arbre classique, tous les
chemins partant de la Tte,  cette exception prs que toutes les feuilles
(identiques entre elles) ont t remplaces par une convergence  un nud
unique, la Queue.

   Le champ Poids de chaque nud est un petit entier (0..255) donnant la
longueur du (plus long) chemin menant de la tte au nud.  Ce champ est utilis
 l'tape de consolidation.

   La consolidation (Consolider_Fuseau) cre le fuseau comme tel, o la
reprsentation des diffrents chemins possibles (un chemin = un mot) est
optimale (ie minimum de nuds et de pointeurs de filiation).  On remarquera
que la condition de Fusion de deux nuds (cf la routine du mme nom) est telle
que le fuseau final est indpendant ( des permutations prs) de l'ordre dans
lequel les fusions sont effectues.

   De mme, le fuseau conserve une proprit importante de l'arbre: tous les
fils d'un mme nud sont distincts.

   La transformation (Transformer_Fuseau) prpare le fuseau  l'tape suivante.
Ceci se rsume au remplacement des champs Poids par un champ
Nombre_de_fils_restant__transcrire, initialement gal  la taille de la Liste
des fils du nud.  Pour des raisons techniques particulires  Pascal, ce champ
ne change pas de nom, mais seulement de contenu.

   La transcription (Transcrire_Fuseau) cre un fichier consultable  partir du
fuseau.


   Les oprations, dans l'ordre normal d'usage, sont:

P Creer_Fuseau (Fuseau)		Cre le Fuseau vide.
P Ajouter_Fuseau (Fuseau, Mot)	Ajoute un Mot (une chane de caractres) au
				Fuseau.
P Consolider_Fuseau (Fuseau)	Consolide le Fuseau.
P Transformer_Fuseau (Fuseau)	Les Poids des nuds sont remplacs par le
				"nombre de fils restant  transcrire".
P Transcrire_Fuseau (Fuseau)	Cre le fichier extrant.

   Il est essentiel d'effectuer tous les ajouts au Fuseau avant de lancer la
Consolidation.  Sinon, (a) le fuseau final ne sera pas optimal, et (b) la
routine de consultation ne marchera pas correctement.
}
{
 -------------------- PROCDURES GNRALES --------------------
}
PROCEDURE Creer_Noeud (VAR Fuseau : TFuseau;
                       VAR PNoeud : TPntrNoeud);
{
   Cre un nud.

Pr:  Le Fuseau existe (et n'a pas encore t Transform).

Post: Un nouveau nud est ajout au fuseau;
      ses liens de parent sont nuls,
      sa Lettre indtermine.

   Cette procdure est appele par Crer_Fuseau et par Insrer.
}
BEGIN { Crer_Nud }
   Obt_Noeud_Mem (PNoeud);
   Fuseau.NNoeuds := Fuseau.NNoeuds + 1;
   Creer_Tamis (PNoeud^.Peres);
   Creer_Liste (PNoeud^.Fils);
END; { Crer_Nud }

PROCEDURE Filiation (VAR Fuseau : TFuseau;
                     Pere, Fils : TPntrNoeud);
{
   tablit le lien de filiation entre les nuds spcifis.

Pr:  Le Fuseau existe (et n'a pas encore t Transform),
      Pre et Fils sont deux de ses nuds.

Post: Pre est maintenant pre de Fils, et Fils est fils de Pre.

   Cette procdure est appele par Insrer et par Fusion.
}
BEGIN { Filiation }
   IF NOT Dans_Liste (Pere^.Fils, Fils)
   THEN BEGIN
      Ajouter_Tete_Liste (Pere^.Fils, Fils);
      Ajouter_Tamis (Fils^.Peres, Pere, Pere^.Lettre);
      Fuseau.NPntrs := Fuseau.NPntrs + 1;
{  ELSE
      le lien existe dj }
   END; { IF }
END; { Filiation }

{
 -------------------- PROCDURES DE CRATION --------------------
}
PROCEDURE Creer_Fuseau (VAR Fuseau : TFuseau);
{
   Cre le fuseau "vide" (ie les nuds Tte et Queue).

Pr:  Le Fuseau n'existe pas encore.
      Sinon, l'usager perdra l'accs  une partie de la mmoire.

Post: Le Fuseau existe et ne comprend que deux nuds, la Tte et la Queue:
      Lettres respectives CarTete et CarQueue, aucun lien de parent.
}
BEGIN { Crer_Fuseau }
   Fuseau.NNoeuds := 0;
   Fuseau.NPntrs  := 0;
   Creer_Noeud (Fuseau, Fuseau.Tete);
   Fuseau.Tete^.Poids := 0;
   Fuseau.Tete^.Lettre  := CarTete;
   Creer_Noeud (Fuseau, Fuseau.Queue);
   Fuseau.Queue^.Poids := 127;
   Fuseau.Queue^.Lettre := CarQueue;
END; { Crer_Fuseau }

{
 -------------------- PROCDURES DE CONSTRUCTION --------------------
}
PROCEDURE Inserer (VAR Fuseau : TFuseau;
                   Mot        : TChaine;
                   I          : INTEGER;
                   PNoeud     : TPntrNoeud);
{
   Insre les Lettres manquantes dans le Fuseau:
   Mot ]I..[ depuis PNoeud jusqu' Fuseau.Queue.

Pr:  Le Fuseau existe (et n'a pas encore t Consolid), et
      PNoeud est un de ses nuds (PNoeud <> Queue).
      Le Mot existe,  1 <= I < LENGTH (Mot)  et  Mot [I] = PNoeud^.Lettre

Post: La chane Mot ]I..[ tablit un lien entre PNoeud et la Queue.
}
VAR
   PPere, PFils : TPntrNoeud;
   K            : INTEGER;

BEGIN { Insrer }
   K := I + 1;
   PPere := PNoeud;
   WHILE K < LENGTH (Mot) DO BEGIN
{
   Q : Mot [K..[ reste  insrer;
       PPere pointe au pre du futur nud Mot [K]
}
      Creer_Noeud (Fuseau, PFils);
      Filiation (Fuseau, PPere, PFils);
      PFils^.Lettre := Mot [K];
      PFils^.Poids := K;
      K := K + 1;
      PPere := PFils;
   END; { WHILE }
   Filiation (Fuseau, PPere, Fuseau.Queue);
END; { Insrer }

FUNCTION Trouver_le_fils (VAR Fuseau : TFuseau;
                          VAR PNoeud : TPntrNoeud;
                          Mot        : TChaine;
                          VAR I      : INTEGER    ) : BOOLEAN;
{
   Tente de trouver le fils prolongeant le chemin Mot [1..I] <--> Tte..PNud

Pr:  Le Fuseau existe (et n'a pas encore t Consolid), et
      PNoeud est un de ses nuds (PNoeud <> Queue)
      1 <= I < LENGTH (Mot)

Post: S'il reste des lettres  trouver (ie si I+1 < LENGTH (Mot)),
      et qu'un des nuds fils de PNoeud ( l'exception de la Queue) a la Lettre
      Mot [I+1],
      ALORS PNoeud avance  ce nud, I est incrment, et Vrai est retourn;
      SINON PNoeud et I sont inchangs, et Faux est retourn.
}
VAR
   Possible : Ternaire;
   PFils    : TPntrNoeud;
   Curseur  : TCurseurListe;

BEGIN { Trouver_le_fils }
   IF Vide_Liste (PNoeud^.Fils) OR
      (I >= (LENGTH (Mot) - 1))
   THEN BEGIN
      Possible := Faux;
   END { THEN }
   ELSE BEGIN
      Debut_Liste (PNoeud^.Fils, Curseur);
      Possible := Indetermine;
      WHILE (Possible = Indetermine) DO BEGIN
{
 Q : Les fils prcdemment examins de PNoeud avaient la mauvaise Lettre
     (ou le fils tait la Queue)
}
         PFils := Lire_Liste (Curseur);
         IF (PFils^.Lettre = Mot [I+1]) AND
            (PFils <> Fuseau.Queue)
         THEN BEGIN
{
   Le fils trouv a la bonne Lettre: il prolonge le chemin
}
            Possible := Vrai;
            PNoeud := PFils;
            I := I + 1;
         END { THEN }
         ELSE BEGIN
{
   Passer au fils suivant  moins qu'il n'en reste plus
}
            IF NOT Suivant_Liste (Curseur) THEN Possible := Faux;
         END; { IF }
      END; { WHILE }
   END; { IF }
   Trouver_le_fils := (Possible = Vrai);
END; { Trouver_le_fils }

PROCEDURE Ajouter_Fuseau (VAR Fuseau : TFuseau;
                          Mot        : TChaine);
{
   Ajoute le Mot au Fuseau.

Pr:  Le Fuseau existe (et n'a pas encore t Consolid).

Post: Mot apparat dans le Fuseau, encadr des caractres CarTete et CarQueue.
}
VAR
   I      : INTEGER;
   PNoeud : TPntrNoeud;

BEGIN { Ajouter_Fuseau }
   Mot := CarTete + Mot + CarQueue;
   I := 1;
   PNoeud := Fuseau.Tete;
   WHILE Trouver_le_fils (Fuseau, PNoeud, Mot, I) DO;
   Inserer (Fuseau, Mot, I, PNoeud);
END; { Ajouter_Fuseau }
{
 -------------------- PROCDURES DE CONSOLIDATION --------------------
}
PROCEDURE Enlever_Noeud (VAR Fuseau : TFuseau;
                         VAR Tamis  : TTamis;
                         PNoeud     : TPntrNoeud);
{
   Enlve le nud PNoeud du fuseau (rompt aussi les liens de parent).
   De plus, s'assure que le nud n'apparat pas dans le Tamis.

Pr:  Le Fuseau existe (et n'a pas encore t Transform), et
      PNoeud est un de ses nuds.

Post: Les liens de parent de PNoeud avec le reste du fuseau ont t rompus,
      puis PNoeud (et ses structures subordonnes) a t dtruit.
}
VAR
   PPere, PFils : TPntrNoeud;
   Curseur      : TCurseurListe;
   Kurseur      : TCurseurTamis;

BEGIN { Enlever_Nud }
{
   Rompre les liens des Pres
}
   IF Debut_Tamis (PNoeud^.Peres, Kurseur)
   THEN BEGIN
      REPEAT
         REPEAT
            PPere := Lire_Liste (Kurseur.Curseur);
            Enlever_Liste (PPere^.Fils, PNoeud);
            Fuseau.NPntrs := Fuseau.NPntrs - 1;
         UNTIL NOT Suivant_Liste (Kurseur.Curseur);
      UNTIL NOT Suivant_Tamis (Kurseur);
      Detruire_Tamis (PNoeud^.Peres);
   END; { IF }

{
   Rompre les liens des Fils
}
   IF NOT Vide_Liste (PNoeud^.Fils)
   THEN BEGIN
      Debut_Liste (PNoeud^.Fils, Curseur);
      REPEAT
         PFils := Lire_Liste (Curseur);
         Enlever_Tamis (PFils^.Peres, PNoeud, PNoeud^.Lettre);
         Fuseau.NPntrs := Fuseau.NPntrs - 1;
      UNTIL NOT Suivant_Liste (Curseur);
      Detruire_Liste (PNoeud^.Fils);
   END; { IF }

{
   L'enlever du Tamis, diminuer le compte, dtruire le nud
}
   Enlever_Tamis (Tamis, PNoeud, PNoeud^.Poids);
   Fuseau.NNoeuds := Fuseau.NNoeuds - 1;
   Lib_Noeud_Mem (PNoeud);
END; { Enlever_Nud }

FUNCTION Fusion (VAR Fuseau  : TFuseau;
                 VAR Tamis   : TTamis;
                 VAR Curseur : TCurseurListe) : BOOLEAN;
{
   Effectue les fusions entre le nud courant de la Liste (indiqu par Curseur)
et ses successeurs dans la Liste si les conditions sont remplies.
Retourne Faux ssi aucune fusion n'a lieu.

Pr:  Le Fuseau existe (et n'a pas encore t Transform),
      le Tamis est constitu de nuds du fuseau classs selon leurs Poids,
      la Liste est tire d'un tamis de pres d'un nud du fuseau, et
      le Curseur pointe  un lment de la Liste.

Post: Le nud courant de la Liste a t fusionn avec ses successeurs dans la
      Liste s'il y a lieu.

   Deux nuds peuvent tre fusionns ssi
a) leurs Lettres sont identiques, et
b) leurs listes de Fils sont identiques (au niveau des pointeurs).

   La fusion consiste  fondre leurs tamis de pres (les pres du second nud
tablissent un lien de filiation avec le premier), puis  dtruire le second
nud.  Le nud fusionn garde le poids le plus lev entre le sien et ceux de
ses partenaires.
}
VAR
   P, Q, R         : TPntrNoeud;
   Curs, Precedent : TCurseurListe;
   Kurseur         : TCurseurTamis;
   Succes          : BOOLEAN;

BEGIN { Fusion }
   Succes := FALSE;
   P := Lire_Liste (Curseur);
   Curs := Curseur;
   Precedent := Curseur;
   WHILE Suivant_Liste (Curs) DO BEGIN
{
   Precedent pointe (dans la Liste) au prdcesseur de Curs;
   P est le nud qui cherche  se fusionner avec les autres
}
      Q := Lire_Liste (Curs);   { Q est le candidat  la fusion }
{
   Les Lettres sont identiques car la Liste argument fait partie d'un Tamis de
   pres classs par Poids = Lettre.
}
      IF Comparer_Listes (P^.Fils, Q^.Fils)
      THEN BEGIN
{
   Effectuer la fusion
}
         Succes := TRUE;
         IF Debut_Tamis (Q^.Peres, Kurseur)
         THEN BEGIN
{
   Chacun des pres R du nud Q adopte P parmi ses fils.
}
            REPEAT
               REPEAT
                  R := Lire_Liste (Kurseur.Curseur);
                  Filiation (Fuseau, R, P);
               UNTIL NOT Suivant_Liste (Kurseur.Curseur);
            UNTIL NOT Suivant_Tamis (Kurseur);
         END; { IF }
{
   Ajustement du Poids de P, et retrait du nud Q du fuseau
}
         IF P^.Poids < Q^.Poids THEN P^.Poids := Q^.Poids;
         Enlever_Noeud (Fuseau, Tamis, Q);
         Curs := Precedent;
      END; { IF }
      Precedent := Curs;
   END; { WHILE }
   Fusion := Succes;
END; { Fusion }

PROCEDURE Consolider_Fuseau (VAR Fuseau : TFuseau);
{
   Consolide le fuseau.

   L'algorithme est comme suit:

   Tant qu'il y a des nuds dans le tamis des tches, on tente de
consolider les listes de pres du premier.  Si une consolidation russit (si
Fusion retourne Vrai), on ajoute le nud consolid au tamis des tches.  Le
tamis des tches ne contient initialement que la Queue.  Le tamis des tches
utilise le Poids du nud comme critre de priorit.

   On ne procde aux pres d'un nud que s'il s'est fusionn avec d'autres
(car, par construction, si un nud ne se consolide pas, il n'y a aucune
consolidation  esprer de ses anctres).

   L'usage du Poids comme critre de priorit permet de minimiser le nombre de
tentatives prmatures de fusionnement.

Pr:  Le Fuseau existe (et n'a pas encore t Transform).

Post: La reprsentation des mots est optimale (du moins on l'espre!).
}
VAR
   P, Q    : TPntrNoeud;
   Tamis   : TTamis;
   Kurseur : TCurseurTamis;
   Niveau,
   Temps   : INTEGER;

BEGIN { Consolider_Fuseau }
   Creer_Tamis (Tamis);
   Ajouter_Tamis (Tamis, Fuseau.Queue, Fuseau.Queue^.Poids);
   Niveau := ORD (Fuseau.Queue^.Poids);
   WRITELN ('   Dbut du traitement du niveau ', Niveau:2);
   Temps := CLOCK;
   WHILE Depiler_Tamis (Tamis, P) DO BEGIN
      IF Niveau <> ORD (P^.Poids)
      THEN BEGIN
         Niveau := ORD (P^.Poids);
         WRITELN ('   Nombre de nuds: ', Fuseau.NNoeuds,
                  '   pointeurs: ', Fuseau.NPntrs);
         WRITELN ('   Temps coul: ', CLOCK - Temps);
         WRITELN ('   Dbut du traitement du niveau ', Niveau:2);
         Temps := CLOCK;
      END; { IF }
{
   Tenter de consolider les pres du nud P
}
      IF Debut_Tamis (P^.Peres, Kurseur)
      THEN BEGIN
         REPEAT
            REPEAT
               IF Fusion (Fuseau, Tamis, Kurseur.Curseur)
               THEN BEGIN
{
   Le pre point par Curseur s'est fusionn avec d'autres pres;
   il faudra tenter de consolider ses pres  lui.
}
                  Q := Lire_Liste (Kurseur.Curseur);
                  Ajouter_Tamis (Tamis, Q, Q^.Poids);
               END; { IF }
            UNTIL NOT Suivant_Liste (Kurseur.Curseur);
         UNTIL NOT Suivant_Tamis (Kurseur);
      END; { IF }
   END; { WHILE }
   Detruire_Tamis (Tamis);
END; { Consolider_Fuseau }
{
 -------------------- PROCDURES DE TRANSFORMATION --------------------
}
PROCEDURE Transformer_Noeud (VAR Liste  : TListe;
                             P          : TPntrNoeud);
{
   Transforme un nud et son sous-fuseau.

Pr:  Le Fuseau existe (et a t Consolid),
      la Liste est constitue de tous les nuds dj transforms du fuseau, et
      P pointe  un nud du fuseau.

Post: Le nud P et son sous-fuseau ont t transforms (s'ils ne l'taient pas
      dj).  Les nuds nouvellement transforms ont t ajouts  la Liste.

   La transformation se rsume au remplacement du Poids par un
Nombre_de_fils_restant__transcrire + 128.

   L'usage du bit haut est possible car 0 <= Poids <= 127
                                    et  0 <= N..   <= 127 (63, en fait)
}
VAR
   Curseur : TCurseurListe;
   Q       : TPntrNoeud;

BEGIN { Transformer_Nud }
   IF ORD (P^.Poids) < 128
   THEN BEGIN
      IF NOT Vide_Liste (P^.Fils)
      THEN BEGIN
{
   Le nud a des fils: d'abord transformer son sous-fuseau
}
         Debut_Liste (P^.Fils, Curseur);
         REPEAT
            Q := Lire_Liste (Curseur);
            Transformer_Noeud (Liste, Q);
         UNTIL NOT Suivant_Liste (Curseur);
      END; { IF }
{
   Transformer le nud lui-mme
}
      P^.Poids := Taille_Liste (P^.Fils) + 128;
      Ajouter_Tete_Liste (Liste, P);
{  ELSE
      Le nud et ses descendants ont dj t traits }
   END; { IF }
END; { Transformer_Nud }

PROCEDURE Transformer_Fuseau (VAR Fuseau : TFuseau);
{
   Transforme les nuds du fuseau.

Pr:  Le Fuseau existe (et a t Consolid).

Post: Les Poids ont t remplacs par un indicateur du "nombre de fils
      restant  transcrire",  l'usage de la procdure de transcription.
}
VAR
   Liste   : TListe;
   Curseur : TCurseurListe;
   P       : TPntrNoeud;

BEGIN { Transformer_Fuseau }
{
   Premire tape:
   Transformer les Poids en Nombre_de_fils_restant__transcrire + 128,
   et crer la Liste des nuds
}
   Creer_Liste (Liste);
   Transformer_Noeud (Liste, Fuseau.Tete);
{
   Deuxime tape:
   teindre le bit haut des Nombre_de_fils_restant__transcrire
}
   Debut_Liste (Liste, Curseur);
   REPEAT
      P := Lire_Liste (Curseur);
      P^.Poids := ORD (P^.Poids) - 128;
   UNTIL NOT Suivant_Liste (Curseur);
   Detruire_Liste (Liste);
END; { Transformer_Fuseau }
{
 -------------------- PROCDURES DE TRANSCRIPTION --------------------
}
{
   L'objet Linaire simule l'organisation squentielle de la mmoire de la
machine sur laquelle on cherche  installer le Fuseau.  Il consiste en une
liste chane de NoeudLin, le nud comptant un champ Carac (qui contient
l'octet qui sera transcrit ultimement en mmoire), un champ Suivant (servant
au chanage des nuds), et un champ Noeud qui pointe au nud correspondant du
Fuseau (lorsqu'il y en a un).

   Les Poids (Nombre_de_fils_restant__transcrire) des nuds prennent la
signification suivante:

0      Nud prt  tre transcrit
1..63  Il reste 1..63 fils  transcrire
255    Nud dj transcrit
}
FUNCTION Coder (Lettre : CHAR) : INTEGER;
{
   Code la Lettre sur 6 bits (1..63).  Le zro est exclu  cause du codage
utilis.

Pr:  Lettre est une lettre lgale
      (la liste des lettres lgales se trouve dans le corps de la fonction).

Post: Retourne un entier compris dans l'intervalle [1..63].

   NB: Le codage prserve l'ordre VAX-ASCII,  tout hasard.
}
BEGIN { Coder }
   CASE Lettre OF
{                il est important que le code zro soit inutilis }
      ' '      : Coder :=  1;	{ expressions }
      '!'      : Coder :=  2;	{ interjections }
      ''''     : Coder :=  3;
      '-'      : Coder :=  4;
      'A'      : Coder :=  5;	{ duc(s)-d'Albe, outre-Atlantique }
      'C'      : Coder :=  6;	{ larme(s)-du-Christ }
      'D'      : Coder :=  7;	{ -Dieu-vat, agnus-Dei, fte(s)-Dieu,
				  filles-Dieu, htel(s)-Dieu, lever-Dieu,
				  mort-Dieu!, pques-Dieu!, prie-Dieu,
				  tte-Dieu! }
      'H'      : Coder :=  8;	{ pH }
      'J'      : Coder :=  9;	{ larme(s)-de-Job, oreille(s)-de-Judas }
      'M'      : Coder := 10;	{ outre-Manche, tte(s)-de-Maure/More }
      'P'      : Coder := 11;	{ premier(s)-Paris }
      'R'      : Coder := 12;	{ outre-Rhin, ruine(s)-de-Rome }
      'S'      : Coder := 13;	{ cent-Suisse(s), sceau(x)-de-Salomon }
      'V'      : Coder := 14;	{ cheveu(x)-de-Vnus, sabot(s)-de-Vnus }
      'a'..'z' : Coder := ORD (Lettre) - 82;	{  97..122 -> 15..40 }
      ''      : Coder := 41;
      ''      : Coder := 42;
      ''      : Coder := 43;
      ''      : Coder := 44;
      ''      : Coder := 45;
      ''      : Coder := 46;
      ''      : Coder := 47;
      ''      : Coder := 48;
      ''      : Coder := 49;
      ''      : Coder := 50;
      ''      : Coder := 51;
      ''      : Coder := 52;
      ''      : Coder := 53;
      ''      : Coder := 54;
      ''      : Coder := 55;
      ''      : Coder := 56;
      ''      : Coder := 57;
      ''      : Coder := 58
   OTHERWISE
{
   Catastrophe!
}
      WRITELN ('Lettre = >', Lettre, '< (CHR (', ORD (Lettre), ')'); HALT
   END; { CASE }
END; { Coder }

FUNCTION Ca_Rentre (Dec,
                    Lon : INTEGER) : BOOLEAN;
{
   Dtermine si un dcalage Dec est codable sur Lon octets.

Pr:  Dec est un entier positif exprimable en 7+7+7+6 bits ou moins,
      1 <= Lon <= 4.

Post: Retourne Vrai ssi Dec est codable sur Lon octets ou moins.

NB: Il n'y a pas de borne infrieure aux domaines de dfinition pour viter
    les instabilits...Il est important que les interrogations successives
    soient croissantes si on veut obtenir le Lon minimal.
}
BEGIN { a_Rentre }
   Ca_Rentre := ((Dec < 64)        AND (Lon = 1)) OR { 6 bits }
                ((Dec < 8192)      AND (Lon = 2)) OR { 7+6 bits = 8k }
                ((Dec < 1048576)   AND (Lon = 3)) OR { 7+7+6 bits = 1M }
                ((Dec < 134217728) AND (Lon = 4));   { 7+7+7+6 bits = 128M }
END; { a_Rentre }

PROCEDURE Tri_Dec (VAR Decalages : TTab64;
                   NFils         : T64);
{
   Trie le tableau des pointeurs fils en ordre croissant de grandeur
(selon tri bulle car le tableau compte rarement plus de 3 ou 4 lments).

Pr:  Decalages [1..NFils] existe.

Post: Decalages [1..NFils] est tri en ordre croissant.
}
VAR
   I, J, L : T64;
   Dec     : INTEGER;

BEGIN { Tri_Dec }
   L := NFils;
   WHILE L > 1 DO BEGIN
{
   Q : Decalages [1..L] reste  trier.  1 <= L <= NFils.
}
      J := 1;
      I := 1;
      WHILE J < L DO BEGIN
         J := J + 1;
         IF Decalages [J] > Decalages [I] THEN I := J;
{
      Q : 1 <= I <= J <= L et
          Decalages [I] est le plus grand terme de l'intervalle [1..J]
}
      END; { WHILE }
      IF I < L
      THEN BEGIN
{
   Decalages [I, L] := Decalages [L, I]
}
         Dec           := Decalages [I];
         Decalages [I] := Decalages [L];
         Decalages [L] := Dec;
      END; { IF }
      L := L - 1;
   END; { WHILE }
END; { Tri_Dec }

PROCEDURE Installer (VAR Lin       : TLineaire;
                     VAR Decalages : TTab64;
                     I,
                     NFils         : T64);
{
   Installe, en tte de Lin, les nuds reprsentant le Dcalage I.
   Notez que les bits suprieurs sont en amont.

Pr:  Lin existe, le tableau Dcalages existe et est lgal (contient NFils
      dcalages, de grandeurs croissantes sur l'intervalle [1..I],
      et 1 <= I <= NFils).
      Chaque Dcalage pointe  un octet-lettre, mesur depuis la tte courante
      de Lin.

Post: Les octets reprsentant le dcalage Dcalages [I] ont t installs en
      tte de Lin, et les Dcalages [1..I[ ont t augments du nombre d'octets
      ajouts  Lin (afin de prserver leur signification).
}
VAR
   Temp     : TPntrNoeudLin;
   J        : T64;
   Dec,
   Decalage : INTEGER;
   Longueur : 1..4;     { On se limite arbitrairement  7+7+7+6 bits = 128 Meg }

BEGIN { Installer }
   IF I > 1
   THEN BEGIN
      Dec := Decalages [I] - Decalages [I - 1];
      Longueur := 0;
      REPEAT
         Longueur := Longueur + 1;
         Decalage := Dec - Longueur;
      UNTIL Ca_Rentre (Decalage, Longueur);
{
   Le Dcalage est exprimable en Longueur octets;
   le pointeur sera obtenu en ajoutant au pointeur prcdent (qui aura t
   augment de Longueur)
}
      FOR J := 1 TO (I - 1) DO BEGIN
         Decalages [J] := Decalages [J] + Longueur;
      END; { FOR }
   END { THEN }
   ELSE BEGIN
      Decalage := Decalages [I];
      Longueur := 0;
      REPEAT
         Longueur := Longueur + 1;
      UNTIL Ca_Rentre (Decalage, Longueur);
   END; { IF }

   Obt_Noeud_Mem (Temp);
   Temp^.Suivant := Lin.Tete;
   Temp^.Noeud   := NIL;
{
   Le bit 6 signale que c'est le dernier pointeur de la liste;
   les bits 0  5 donnent la partie basse du dcalage.
}
   IF I = NFils
   THEN BEGIN
      Temp^.Carac := 64 + Decalage MOD 64;
   END { THEN }
   ELSE BEGIN
      Temp^.Carac := Decalage MOD 64;
   END; { IF }
   Decalage := Decalage DIV 64;

   Lin.Tete := Temp;
   Lin.NOctets := Lin.NOctets + 1;
   Longueur := Longueur - 1;

   WHILE Longueur > 0 DO BEGIN
{
   Q : Il reste une tranche de 7 bits  installer en amont des autres.
       Ces sept bits sont les bits infrieurs de Dcalage.
}
      Obt_Noeud_Mem (Temp);
      Temp^.Suivant := Lin.Tete;
      Temp^.Noeud   := NIL;
{
   Le bit 7 signale que le pointeur se continue sur l'octet suivant
}
      Temp^.Carac   := 128 + Decalage MOD 128;
      Decalage := Decalage DIV 128;

      Lin.Tete := Temp;
      Lin.NOctets := Lin.NOctets + 1;
      Longueur := Longueur - 1;
   END; { WHILE }
END; { Installer }

PROCEDURE Ajouter_Lin (VAR Fuseau : TFuseau;
                       VAR Lin    : TLineaire;
                       Feuille    : BOOLEAN;
                       NFils      : INTEGER;
                       Lettre     : CHAR;
                       P          : TPntrNoeud);
{
   Ajoute un nud et ses pointeurs  l'objet Linaire.

Pr:  Le Fuseau existe (et a t Transform),
      P est un de ses nuds (P a la lettre Lettre, a NFils fils, et compte la
      Queue parmi ses fils ssi Feuille est vrai; mais surtout, P n'est pas
      dj transcrit bien que transcriptible), et
      les "octets" Lin.Tete et suivants concernent les autres nuds.

Post: Lin.Tete dbute la reprsentation du nud P.
}
VAR
   Curs,
   Tete      : TPntrNoeudLin;
   Q         : TPntrNoeud;
   Curseur   : TCurseurListe;
   Index,
   Octet     : INTEGER;
   Decalages : TTab64;
   I         : T64;

BEGIN { Ajouter_Lin }
   Index := Lin.NOctets; { Noter la taille de l'objet Linaire }
   Octet := 0;
{
   Si c'est une fin-de-mot (ie si la Queue est un Fils)...
}
   IF Feuille THEN NFils := NFils - 1;
{
   Si le nud suivant de l'objet linaire est un de ses fils, bit 6 allum
   et on ne tient plus compte de ce nud parmi les fils.
}
   IF Dans_Liste (P^.Fils, Lin.Tete^.Noeud)
   THEN BEGIN
      Octet := Octet + 64;
      NFils := NFils - 1;
   END; { IF }
{
   S'il ne reste plus de fils, bit 7 allum
}
   IF NFils = 0 THEN Octet := Octet + 128;
{
   Les six autres bits donns par la Lettre code.
}
   Octet := Octet + Coder (Lettre);

{
   Premier octet (octet-nud)
}
   Obt_Noeud_Mem (Tete);
   Curs := Tete;
   Curs^.Carac := Octet;
   Curs^.Noeud := P;
   Lin.NOctets := Lin.NOctets + 1;

{
   Second octet (octet-dcalage), signale la fin-de-mot s'il y a lieu
}
   IF Feuille
   THEN BEGIN
      Obt_Noeud_Mem (Curs^.Suivant);
      Curs := Curs^.Suivant;
      Curs^.Carac := CHR (0);
      Curs^.Noeud := NIL;
      Lin.NOctets := Lin.NOctets + 1;
   END; { IF }

{
   Octets suivants (octets-dcalages), donnent les pointeurs
}
   IF NFils > 0
   THEN BEGIN
      Debut_Liste (P^.Fils, Curseur);
      I := 1;
      REPEAT
         Q := Lire_Liste (Curseur);
         IF (Q <> Fuseau.Queue) AND
            (Q <> Lin.Tete^.Noeud)
         THEN BEGIN
            Decalages [I] := Index - Q^.Coor;
            I := I + 1;
         END; { IF }
      UNTIL NOT Suivant_Liste (Curseur) { OR I > NFils };

      Tri_Dec (Decalages, NFils);

      FOR I := NFils DOWNTO 1 DO BEGIN
         Installer (Lin, Decalages, I, NFils);
      END; { FOR }
   END; { IF }

   Curs^.Suivant := Lin.Tete;
   Lin.Tete := Tete;
END; { Ajouter_Lin }

PROCEDURE Transcrire_Noeud (VAR Fuseau : TFuseau;
                            VAR Lin    : TLineaire;
                            P          : TPntrNoeud);
{
   Tente de transcrire un nud dans l'objet Linaire.

Pr:  Le Fuseau existe (et a t Transform),
      le Lin contient les nuds transcrits, et
      P est un nud du fuseau (dj transcrit ou non).
 
Post: Si tous les fils du nud sont dj transcrits et que le nud lui-mme ne
      l'est pas dj, on le transcrit et on passe  ses pres.
      Ceci implique que le Poids du nud change (devient 255), et qu'il voit
      sa liste de Fils remplace par la coordonne (Coor) de son image dans
      l'objet Linaire (coordonne mesure depuis la fin du Lin).

   La routine cherche  transcrire rcursivement les pres du nud afin de
maximiser l'usage du bit "fils suit".
}
VAR
   Kurseur : TCurseurTamis;
   Q       : TPntrNoeud;
   Bidon   : BOOLEAN;

BEGIN { Transcrire_Nud }
   IF ORD (P^.Poids) = 0
   THEN BEGIN
{
   Transcrire le nud
}
      Ajouter_Lin (Fuseau, Lin, Dans_Liste (P^.Fils, Fuseau.Queue),
                                Taille_Liste (P^.Fils),
                                P^.Lettre,
                                P);
{
   Mettre  jour les Nombres_de_fils_restant__transcrire
   du nud et de ses pres
}
      P^.Poids := 255;
      IF Debut_Tamis (P^.Peres, Kurseur)
      THEN BEGIN
         REPEAT
            REPEAT
               Q := Lire_Liste (Kurseur.Curseur);
               Q^.Poids := ORD (Q^.Poids) - 1;
            UNTIL NOT Suivant_Liste (Kurseur.Curseur);
         UNTIL NOT Suivant_Tamis (Kurseur);
{
   Remplacer le pointeur Fils (dsormais inutile) par la coordonne du
   nud dans l'objet Linaire (mesure depuis sa fin).
}
         Detruire_Liste (P^.Fils);
         P^.Coor := Lin.NOctets;
{
   Tenter de transcrire ses pres
}
         Bidon := Debut_Tamis (P^.Peres, Kurseur);
         REPEAT
            REPEAT
               Q := Lire_Liste (Kurseur.Curseur);
               Transcrire_Noeud (Fuseau, Lin, Q);
            UNTIL NOT Suivant_Liste (Kurseur.Curseur);
         UNTIL NOT Suivant_Tamis (Kurseur);
      END; { IF }
{  ELSE
      Il manque des fils ou le nud est dj transcrit; reprendre plus bas }
   END; { IF }
END; { Transcrire_Nud }

PROCEDURE Transcrire_Fuseau (VAR Fuseau  : TFuseau;
                             VAR Noctets : INTEGER);
{
   Transcrit le Fuseau en un fichier linaire consultable, via l'objet Linaire.

Pr:  Le Fuseau existe (et a t Transform).

Post: Le fichier Dest contient un dico consultable.

   La transcription se fait  rebours (ie en commenant par la Queue) afin de
pouvoir calculer les dcalages.
}
VAR
   Lin     : TLineaire;
   Kurseur : TCurseurTamis;
   Q       : TPntrNoeudLin;
   R       : TPntrNoeud;
   I       : INTEGER;
   Bidon   : BOOLEAN;

BEGIN { Transcrire_Fuseau }
{
   On doit crer un nud de queue bidon pour Lin, afin de s'viter des
   problmes avec le test "suivant" (cf Ajouter_Lin)
}
   Obt_Noeud_Mem (Lin.Tete);
   Lin.Tete^.Noeud   := NIL;
   Lin.Tete^.Suivant := NIL;
{  Lin.Tete^.Carac   := CHR (0); }
   Lin.NOctets := 0;
   IF Debut_Tamis (Fuseau.Queue^.Peres, Kurseur)
   THEN BEGIN
{
   Ajuster les poids des pres de la Queue
   (faire comme si la Queue tait dj transcrite)
}
      REPEAT
         REPEAT
            R := Lire_Liste (Kurseur.Curseur);
            R^.Poids := ORD (R^.Poids) - 1;
         UNTIL NOT Suivant_Liste (Kurseur.Curseur);
      UNTIL NOT Suivant_Tamis (Kurseur);
      Bidon := Debut_Tamis (Fuseau.Queue^.Peres, Kurseur);
{
   Lancer les transcriptions successives
}
      REPEAT
         REPEAT
            R := Lire_Liste (Kurseur.Curseur);
            Transcrire_Noeud (Fuseau, Lin, R);
         UNTIL NOT Suivant_Liste (Kurseur.Curseur);
      UNTIL NOT Suivant_Tamis (Kurseur);
   END; { IF }

{
   L'objet linaire est complet: en copier les octets au fichier Dest
   (et le dtruire par la mme occasion)
}
   NOctets := Lin.NOctets;
   FOR I := 0 TO 3 DO WRITE (Dest, Lin.Octets [I]);
   FOR I := 1 TO Lin.NOctets DO BEGIN
      WRITE (Dest, Lin.Tete^.Carac);
{     Q := Lin.Tete; }
      Lin.Tete := Lin.Tete^.Suivant;
{     Lib_Noeud_Mem (Q); }
   END; { WHILE }
{
   Destruction du nud de queue bidon
}
{  Lib_Noeud_Mem (Lin.Tete); }
END; { Transcrire_Fuseau }
{
 *************************************************************************
}
BEGIN { Dictionnaire }
   WRITE ('Fichier des sources? ');
   READLN (Nom);
   OPEN (Sources, Nom, OLD);
   RESET (Sources);
   WRITELN; WRITELN;

   Init_Mem;
   Creer_Fuseau (Fuseau);

   WHILE NOT EOF (Sources) DO BEGIN
      READLN (Sources, Nom);
      OPEN (Source, Nom, OLD);
      RESET (Source);
      WRITELN ('Lecture du fichier source ', Nom);
      Horloge := CLOCK;
      WHILE NOT EOF (Source) DO BEGIN
         READLN (Source, Mot);
         Ajouter_Fuseau (Fuseau, Mot);
      END; { WHILE }
      CLOSE (Source);
      WRITELN ('Construction termine aprs   t = ', CLOCK - Horloge);
      WRITELN ('Nombre de nuds: ', Fuseau.NNoeuds,
               '   pointeurs: ', Fuseau.NPntrs);
      WRITELN;

      Horloge := CLOCK;
      Consolider_Fuseau (Fuseau);
      WRITELN ('Consolidation termine aprs  t = ', CLOCK - Horloge);
      WRITELN ('Nombre de nuds: ', Fuseau.NNoeuds,
               '   pointeurs: ', Fuseau.NPntrs);
      WRITELN;
   END; { WHILE }
   CLOSE (Sources);

   WRITELN ('Transformation debute');
   Horloge := CLOCK;
   Transformer_Fuseau (Fuseau);
   WRITELN ('Transformation termine aprs t = ', CLOCK - Horloge);
   WRITELN;

   WRITE ('Fichier o transcrire le dictionnaire? ');
   READLN (Nom);
   OPEN (Dest, Nom, NEW);
   REWRITE (Dest);
   WRITELN; WRITELN;

   Horloge := CLOCK;
   Transcrire_Fuseau (Fuseau, NOctets);
   CLOSE (Dest);
   WRITELN ('Transcription termine aprs  t = ', CLOCK - Horloge);
   WRITELN ('Le fichier compte ', NOctets, ' octets');
   WRITELN;

{  Detruire_Fuseau (Fuseau); }
END. { Dictionnaire }
