PROGRAM Premier (INPUT, OUTPUT);
{
   Daniel U. Thibault     78 840 046
   13 Avril 1988, rvis 25 Juillet 1988 et 13 Dcembre 1988

   Transformation du vocabulaire stnographique en numr.

   Entres:	Un fichier numrant les fichiers contenant le vocabulaire
		sous sa forme stnographique.
		Un fichier contenant les paires conjugateur-fichier description.

   Sorties:	Le fichier des majuscules rejetes.
		Le fichier du vocabulaire numr au long (dans l'ordre
		approximatif, et avec rptitions).
}
TYPE
   TChaine     = VARYING [32] OF CHAR;
   TNomFichier = VARYING [80] OF CHAR;

   %INCLUDE 'Cnjgtrs.typ'

VAR
   Ens_Majuscules : SET OF CHAR;  { Ensemble des majuscules }
   C              : TOCnjgtrs;    { Objet conjugateurs }
   Nom_Source     : TChaine;      { Nom du fichier source }
   Sources,                       { Fichier des sources }
   Source,                        { Fichier source (vocab stno) }
   Vocabulaire,                   { Vocabulaire numr }
   Majuscules     : TEXT;         { Majuscules non traites }

%INCLUDE 'Cnjgtrs.pas'

PROCEDURE Traitement;
{
   Traite une Source

Pr:  La Source (fichier-texte) est prte  la lecture, et ne comprend que
      des lignes non-vides.  Les @, lorsque prsents, sont toujours suivis
      d'une Cl lgale.  Ens_Majuscules a t cr.

Post: Le vocabulaire numr dcrit par le vocabulaire stnographique Source a
      t gnr (les lignes dbutant par une majuscule ajoutes au fichier des
      rejets (Majuscules), les autres au fichier Vocabulaire) et Source n'a
      plus qu' tre ferm.

NB: Les chos cran ont t neutraliss.
    Routines particulires au VAX:
  INDEX (Chane, Car)   Retourne l'indice i tel que Chane [i] = Car; si le
			Car n'apparat pas dans la Chane, i = 0.
  SUBSTR (Chane, Db, Lon)	Retourne la sous-chane de longueur Lon
				dbutant  Chane [Db].
}
VAR
   Prefixe,                { Radical de la Ligne }
   Suffixe,                { Production de l'objet Conjugateurs }
   Ligne    : TChaine;     { Tampon source }
   Virgule,                { Indice de la virgule dans la Ligne }
   Cesure   : INTEGER;     { Indice du @ dans la Ligne }

BEGIN { Traitement }
   WHILE NOT EOF (Source) DO BEGIN
{
 Q: Les Lignes prcdentes ont t traites
}
      READLN (Source, Ligne);
      IF Ligne [1] IN Ens_Majuscules
      THEN BEGIN
{
   Cas Xxxxx
}
         WRITELN (Majuscules, Ligne);
{        WRITELN (Ligne : 75); }
      END { THEN }
      ELSE BEGIN
         Virgule := INDEX (Ligne, ',');
         IF Virgule > 0
         THEN BEGIN
{
   Cas xxxxx,z
   imprimer xxxxx
}
            Prefixe := SUBSTR (Ligne, 1, Virgule - 1);
            WRITELN (Vocabulaire, Prefixe);
{           WRITELN (Prefixe); }
{
   puis xxxxxz
}
            WRITELN (Vocabulaire, Prefixe + Ligne [Virgule + 1]);
{           WRITELN (Prefixe + Ligne [Virgule + 1]); }
         END { THEN }
         ELSE BEGIN
            Cesure := INDEX (Ligne, '@');
            IF Cesure > 0
            THEN BEGIN
{
   Cas xxxxx@zzz
}
               Trouver_Cnjgtrs (C, SUBSTR (Ligne,
                                           Cesure + 1,
                                           LENGTH (Ligne) - Cesure));
               Prefixe := SUBSTR (Ligne, 1, Cesure - 1);
               WHILE Suffixe_Cnjgtrs (C, Suffixe) DO BEGIN
                  WRITELN (Vocabulaire, Prefixe + Suffixe);
 {                WRITELN (Prefixe + Suffixe); }
               END; { WHILE }
            END { THEN }
            ELSE BEGIN
{
   Cas xxxxx (car ni Xxxxxx  ni xxxxx,z  ni xxxxx@zzz)
}
               WRITELN (Vocabulaire, Ligne);
{              WRITELN (Ligne); }
            END; { IF contient "@" }
         END; { IF contient "," }
      END; { IF dbute par une majuscule }
   END; { WHILE }
END; { Traitement }

PROCEDURE Init;
{
   Initialisations

Pr:  Zip.

Post: Ens_Majuscules a t cr.

NB: Le code dpend du jeu de caractres VAX-ASCII.
}
VAR
   C : CHAR;

BEGIN { Init }
   Ens_Majuscules := [];
{
   A..Z
}
   FOR C := 'A' TO 'Z' DO BEGIN
      Ens_Majuscules := Ens_Majuscules + [C];
   END; { FOR }
{
   A grave..I trma
}
   FOR C := CHR (192) TO CHR (207) DO BEGIN
      Ens_Majuscules := Ens_Majuscules + [C];
   END; { FOR }
{
   N tilde..Y trma
}
   FOR C := CHR (209) TO CHR (221) DO BEGIN
      Ens_Majuscules := Ens_Majuscules + [C];
   END; { FOR }
END; { Init }

BEGIN { Premier }
   Init;
   WRITE ('Nom du fichier des conjugateurs? ');
   READLN (Nom_Source);
   WRITELN; WRITELN;
   Creer_Cnjgtrs (C, Nom_Source);

   WRITE ('Nom du fichier vocabulaire  crer? ');
   READLN (Nom_Source);
   WRITELN; WRITELN;
   OPEN (Vocabulaire, Nom_Source);
   REWRITE (Vocabulaire);

   WRITE ('Nom du fichier majuscules  crer? ');
   READLN (Nom_Source);
   WRITELN; WRITELN;
   OPEN (Majuscules, Nom_Source);
   REWRITE (Majuscules);

   WRITE ('Fichier des sources? ');
   READLN (Nom_Source);
   WRITELN; WRITELN;
   OPEN (Sources, Nom_Source, HISTORY := READONLY);
   RESET (Sources);

   WHILE NOT EOF (Sources) DO BEGIN
{
 Q: Les sources prcdentes ont t traites
}
      READLN (Sources, Nom_Source);
      OPEN (Source, Nom_Source, HISTORY := READONLY);
      RESET (Source);
      Traitement;
      CLOSE (Source);
   END; { WHILE }

   CLOSE (Sources);
   CLOSE (Majuscules);
   CLOSE (Vocabulaire);
   Detruire_Cnjgtrs (C);
END. { Premier }
